#include <gst/gstplugin.h> 

#include "gst-alsamidi-bin.h"
#include "gst-alsamidi-src.h"
#include "gst-alsamidi-sink.h"

#include <gtk/gtk.h>

extern "C" GtkWidget *gst_editor_new(GstElement *element);


extern "C" gboolean plugin_init(GstPlugin *plugin)
{ 
	return gst_element_register(plugin, "alsamidisrc", GST_RANK_PRIMARY, GST_TYPE_ALSAMIDI_SRC)
	    && gst_element_register(plugin, "alsamidisink", GST_RANK_PRIMARY, GST_TYPE_ALSAMIDI_SINK)
	    && gst_element_register(plugin, "alsamidibin", GST_RANK_PRIMARY, GST_TYPE_ALSAMIDI_BIN);
;
}

extern "C" void plugin_exit(GstPlugin *plugin)
{
}

extern "C" void gst_register(void)
{
	static GstPluginDesc plugin_desc =
	{
		GST_VERSION_MAJOR,
		GST_VERSION_MINOR,
		"alsamidi",
		"Midi I/O with alsa",
		plugin_init,
		plugin_exit,
		"0.0.1",
		GST_LICENSE_UNKNOWN,
		"pipo",
		"homepage",
		GST_PADDING_INIT
	};

	_gst_plugin_register_static(&plugin_desc);
}


int main(int argc, char *argv[])
{
	gst_init(&argc, &argv);
	gst_register();

/*
	Gnome::Main kit("Test", "0.1", Gnome::UI::module_info_get(), argc, argv);
	GstElement *bin = ::gst_element_factory_make("bin", NULL);
	GtkWidget *editor = ::gst_editor_new(bin);
	kit.run();
*/
	
	GstElement *pipeline = gst_parse_launch("pipeline.( alsamidibin.( alsamidisrc name=\"src\" ! alsamidisink name=\"sink\" ) )", NULL);
	
	gst_element_set_state(pipeline, GST_STATE_PLAYING);
	while(gst_bin_iterate(GST_BIN(pipeline)))
		;
	gst_element_set_state(pipeline, GST_STATE_NULL);
		
	return 0;
}
